From 18ed79b04c0e962e355685e0b1f564c5981d899e Mon Sep 17 00:00:00 2001
From: David Tolnay <dtolnay@gmail.com>
Date: Dec 29 2020 02:21:46 +0000
Subject: [PATCH 1848/2232] Add impl Debug for WeakPtr


---

diff --git a/src/weak_ptr.rs b/src/weak_ptr.rs
index 3875a78..7fc4c78 100644
--- a/src/weak_ptr.rs
+++ b/src/weak_ptr.rs
@@ -1,7 +1,7 @@
 use crate::shared_ptr::{SharedPtr, SharedPtrTarget};
 use crate::string::CxxString;
 use core::ffi::c_void;
-use core::fmt::Display;
+use core::fmt::{self, Debug, Display};
 use core::marker::PhantomData;
 use core::mem::MaybeUninit;
 
@@ -82,6 +82,15 @@ where
     }
 }
 
+impl<T> Debug for WeakPtr<T>
+where
+    T: Debug + WeakPtrTarget + SharedPtrTarget,
+{
+    fn fmt(&self, formatter: &mut fmt::Formatter) -> fmt::Result {
+        Debug::fmt(&self.upgrade(), formatter)
+    }
+}
+
 // Methods are private; not intended to be implemented outside of cxxbridge
 // codebase.
 pub unsafe trait WeakPtrTarget {

